import V from "dayjs";
import { inject as mt, computed as H, defineComponent as q, openBlock as O, createElementBlock as G, createElementVNode as I, Fragment as Z, renderList as at, unref as D, normalizeStyle as F, renderSlot as U, createTextVNode as rt, toDisplayString as K, createCommentVNode as W, toRefs as J, ref as Y, watch as Bt, nextTick as xt, createBlock as ot, Teleport as At, createVNode as pt, Transition as Ut, withCtx as N, useSlots as Ft, provide as ht, onMounted as It, onUnmounted as jt, withModifiers as zt, mergeProps as Pt, TransitionGroup as Vt } from "vue";
var it = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {}, Et = { exports: {} };
(function(o, x) {
  (function(c, w) {
    o.exports = w();
  })(it, function() {
    return function(c, w) {
      w.prototype.isSameOrBefore = function(d, u) {
        return this.isSame(d, u) || this.isBefore(d, u);
      };
    };
  });
})(Et);
const Nt = Et.exports;
var Ct = { exports: {} };
(function(o, x) {
  (function(c, w) {
    o.exports = w();
  })(it, function() {
    return function(c, w) {
      w.prototype.isSameOrAfter = function(d, u) {
        return this.isSame(d, u) || this.isAfter(d, u);
      };
    };
  });
})(Ct);
const qt = Ct.exports;
var Dt = { exports: {} };
(function(o, x) {
  (function(c, w) {
    o.exports = w();
  })(it, function() {
    return function(c, w, d) {
      w.prototype.isBetween = function(u, s, l, i) {
        var t = d(u), a = d(s), n = (i = i || "()")[0] === "(", r = i[1] === ")";
        return (n ? this.isAfter(t, l) : !this.isBefore(t, l)) && (r ? this.isBefore(a, l) : !this.isAfter(a, l)) || (n ? this.isBefore(t, l) : !this.isAfter(t, l)) && (r ? this.isAfter(a, l) : !this.isBefore(a, l));
      };
    };
  });
})(Dt);
const Xt = Dt.exports;
var _t = { exports: {} };
(function(o, x) {
  (function(c, w) {
    o.exports = w();
  })(it, function() {
    var c = { LTS: "h:mm:ss A", LT: "h:mm A", L: "MM/DD/YYYY", LL: "MMMM D, YYYY", LLL: "MMMM D, YYYY h:mm A", LLLL: "dddd, MMMM D, YYYY h:mm A" }, w = /(\[[^[]*\])|([-_:/.,()\s]+)|(A|a|YYYY|YY?|MM?M?M?|Do|DD?|hh?|HH?|mm?|ss?|S{1,3}|z|ZZ?)/g, d = /\d\d/, u = /\d\d?/, s = /\d*[^-_:/,()\s\d]+/, l = {}, i = function(g) {
      return (g = +g) + (g > 68 ? 1900 : 2e3);
    }, t = function(g) {
      return function(v) {
        this[g] = +v;
      };
    }, a = [/[+-]\d\d:?(\d\d)?|Z/, function(g) {
      (this.zone || (this.zone = {})).offset = function(v) {
        if (!v || v === "Z")
          return 0;
        var y = v.match(/([+-]|\d\d)/g), m = 60 * y[1] + (+y[2] || 0);
        return m === 0 ? 0 : y[0] === "+" ? -m : m;
      }(g);
    }], n = function(g) {
      var v = l[g];
      return v && (v.indexOf ? v : v.s.concat(v.f));
    }, r = function(g, v) {
      var y, m = l.meridiem;
      if (m) {
        for (var p = 1; p <= 24; p += 1)
          if (g.indexOf(m(p, 0, v)) > -1) {
            y = p > 12;
            break;
          }
      } else
        y = g === (v ? "pm" : "PM");
      return y;
    }, b = { A: [s, function(g) {
      this.afternoon = r(g, !1);
    }], a: [s, function(g) {
      this.afternoon = r(g, !0);
    }], S: [/\d/, function(g) {
      this.milliseconds = 100 * +g;
    }], SS: [d, function(g) {
      this.milliseconds = 10 * +g;
    }], SSS: [/\d{3}/, function(g) {
      this.milliseconds = +g;
    }], s: [u, t("seconds")], ss: [u, t("seconds")], m: [u, t("minutes")], mm: [u, t("minutes")], H: [u, t("hours")], h: [u, t("hours")], HH: [u, t("hours")], hh: [u, t("hours")], D: [u, t("day")], DD: [d, t("day")], Do: [s, function(g) {
      var v = l.ordinal, y = g.match(/\d+/);
      if (this.day = y[0], v)
        for (var m = 1; m <= 31; m += 1)
          v(m).replace(/\[|\]/g, "") === g && (this.day = m);
    }], M: [u, t("month")], MM: [d, t("month")], MMM: [s, function(g) {
      var v = n("months"), y = (n("monthsShort") || v.map(function(m) {
        return m.slice(0, 3);
      })).indexOf(g) + 1;
      if (y < 1)
        throw new Error();
      this.month = y % 12 || y;
    }], MMMM: [s, function(g) {
      var v = n("months").indexOf(g) + 1;
      if (v < 1)
        throw new Error();
      this.month = v % 12 || v;
    }], Y: [/[+-]?\d+/, t("year")], YY: [d, function(g) {
      this.year = i(g);
    }], YYYY: [/\d{4}/, t("year")], Z: a, ZZ: a };
    function C(g) {
      var v, y;
      v = g, y = l && l.formats;
      for (var m = (g = v.replace(/(\[[^\]]+])|(LTS?|l{1,4}|L{1,4})/g, function(M, _, L) {
        var k = L && L.toUpperCase();
        return _ || y[L] || c[L] || y[k].replace(/(\[[^\]]+])|(MMMM|MM|DD|dddd)/g, function(S, T, $) {
          return T || $.slice(1);
        });
      })).match(w), p = m.length, e = 0; e < p; e += 1) {
        var f = m[e], h = b[f], B = h && h[0], E = h && h[1];
        m[e] = E ? { regex: B, parser: E } : f.replace(/^\[|\]$/g, "");
      }
      return function(M) {
        for (var _ = {}, L = 0, k = 0; L < p; L += 1) {
          var S = m[L];
          if (typeof S == "string")
            k += S.length;
          else {
            var T = S.regex, $ = S.parser, tt = M.slice(k), z = T.exec(tt)[0];
            $.call(_, z), M = M.replace(z, "");
          }
        }
        return function(j) {
          var R = j.afternoon;
          if (R !== void 0) {
            var P = j.hours;
            R ? P < 12 && (j.hours += 12) : P === 12 && (j.hours = 0), delete j.afternoon;
          }
        }(_), _;
      };
    }
    return function(g, v, y) {
      y.p.customParseFormat = !0, g && g.parseTwoDigitYear && (i = g.parseTwoDigitYear);
      var m = v.prototype, p = m.parse;
      m.parse = function(e) {
        var f = e.date, h = e.utc, B = e.args;
        this.$u = h;
        var E = B[1];
        if (typeof E == "string") {
          var M = B[2] === !0, _ = B[3] === !0, L = M || _, k = B[2];
          _ && (k = B[2]), l = this.$locale(), !M && k && (l = y.Ls[k]), this.$d = function(tt, z, j) {
            try {
              if (["x", "X"].indexOf(z) > -1)
                return new Date((z === "X" ? 1e3 : 1) * tt);
              var R = C(z)(tt), P = R.year, et = R.month, Gt = R.day, Yt = R.hours, $t = R.minutes, Rt = R.seconds, Ht = R.milliseconds, yt = R.zone, st = new Date(), lt = Gt || (P || et ? 1 : st.getDate()), ut = P || st.getFullYear(), nt = 0;
              P && !et || (nt = et > 0 ? et - 1 : st.getMonth());
              var ct = Yt || 0, dt = $t || 0, ft = Rt || 0, gt = Ht || 0;
              return yt ? new Date(Date.UTC(ut, nt, lt, ct, dt, ft, gt + 60 * yt.offset * 1e3)) : j ? new Date(Date.UTC(ut, nt, lt, ct, dt, ft, gt)) : new Date(ut, nt, lt, ct, dt, ft, gt);
            } catch {
              return new Date("");
            }
          }(f, E, h), this.init(), k && k !== !0 && (this.$L = this.locale(k).$L), L && f != this.format(E) && (this.$d = new Date("")), l = {};
        } else if (E instanceof Array)
          for (var S = E.length, T = 1; T <= S; T += 1) {
            B[1] = E[T - 1];
            var $ = y.apply(this, B);
            if ($.isValid()) {
              this.$d = $.$d, this.$L = $.$L, this.init();
              break;
            }
            T === S && (this.$d = new Date(""));
          }
        else
          p.call(this, e);
      };
    };
  });
})(_t);
const Zt = _t.exports, kt = Symbol("CHART_ROWS_KEY"), Mt = Symbol("CONFIG_KEY"), Lt = Symbol("EMIT_BAR_EVENT_KEY");
function A() {
  const o = mt(Mt);
  if (!o)
    throw Error("Failed to inject config!");
  return o;
}
function Q(o = A()) {
  const { chartStart: x, chartEnd: c, barStart: w, barEnd: d, dateFormat: u } = o, s = H(() => i(x.value)), l = H(() => i(c.value)), i = (t, a) => {
    if (typeof t == "string")
      return V(t, u.value, !0);
    if (a == null)
      throw Error(
        "VueGanttastic - toDayjs: passed a GanttBarObject as value, but did not provide start|end parameter."
      );
    const n = a === "start" ? t[w.value] : t[d.value];
    return V(n, u.value, !0);
  };
  return {
    chartStartDayjs: s,
    chartEndDayjs: l,
    toDayjs: i
  };
}
function Ot() {
  const { precision: o } = A(), { chartStartDayjs: x, chartEndDayjs: c } = Q(), w = H(() => {
    switch (o == null ? void 0 : o.value) {
      case "hour":
        return "day";
      case "day":
        return "month";
      case "month":
        return "year";
      default:
        throw new Error(
          "Precision prop incorrect. Must be one of the following: 'hour', 'day', 'month'"
        );
    }
  }), d = {
    hour: "HH",
    date: "DD.MMM ",
    day: "DD.MMM ",
    month: "MMMM YYYY",
    year: "YYYY"
  };
  return {
    timeaxisUnits: H(() => {
      const s = [], l = [], i = w.value === "day" ? "date" : w.value, t = o.value;
      let a = x.value.startOf(t);
      const n = c.value.diff(x.value, "minutes", !0);
      let r = 0, b = a[i]();
      for (; a.isBefore(c.value) || a.isSame(c.value); ) {
        if (a[i]() !== b) {
          let m = 0;
          if (s.length === 0)
            m = a.startOf(i).diff(x.value, "minutes", !0) / n * 100;
          else if (a.isSameOrAfter(c.value))
            m = c.value.diff(
              a.subtract(1, i).startOf(i),
              "minutes",
              !0
            ) / n * 100;
          else {
            const p = a.startOf(i), e = a.subtract(1, i).startOf(i);
            m = p.diff(e, "minutes", !0) / n * 100;
          }
          s.push({
            label: a.subtract(1, i).format(d[i]),
            value: String(b),
            width: String(m) + "%"
          }), r = 0, b = a[i]();
        }
        let v = 0;
        l.length === 0 ? v = a.endOf(t).diff(x.value, "minutes", !0) / n * 100 : a.add(1, t).isSameOrAfter(c.value) ? v = c.value.diff(a.startOf(t), "minutes", !0) / n * 100 : v = a.endOf(t).diff(a.startOf(t), "minutes", !0) / n * 100, l.push({
          label: a.format(d[t]),
          value: String(a[t === "day" ? "date" : t]()),
          width: String(v) + "%"
        });
        const y = a;
        a = a.add(1, t), (a.isBefore(c.value) || a.isSame(c.value)) && (r += a.diff(y, "minutes", !0));
      }
      const C = c.value.isSame(c.value.startOf(i)) ? c.value[i]() - 1 : c.value[i]();
      return s.some((v) => v.value === String(C)) || (r += c.value.diff(
        a.subtract(1, t),
        "minutes",
        !0
      ), s.push({
        label: c.value.format(d[i]),
        value: String(b),
        width: `${r / n * 100}%`
      })), { upperUnits: s, lowerUnits: l };
    })
  };
}
const Kt = { class: "g-timeaxis" }, Wt = { class: "g-timeunits-container" }, Jt = { class: "g-timeunits-container" }, Qt = /* @__PURE__ */ q({
  __name: "GGanttTimeaxis",
  setup(o) {
    const { precision: x, colors: c } = A(), { timeaxisUnits: w } = Ot();
    return (d, u) => (O(), G("div", Kt, [
      I("div", Wt, [
        (O(!0), G(Z, null, at(D(w).upperUnits, ({ label: s, value: l, width: i }, t) => (O(), G("div", {
          key: s,
          class: "g-upper-timeunit",
          style: F({
            background: t % 2 === 0 ? D(c).primary : D(c).secondary,
            color: D(c).text,
            width: i
          })
        }, [
          U(d.$slots, "upper-timeunit", {
            label: s,
            value: l
          }, () => [
            rt(K(s), 1)
          ])
        ], 4))), 128))
      ]),
      I("div", Jt, [
        (O(!0), G(Z, null, at(D(w).lowerUnits, ({ label: s, value: l, width: i }, t) => (O(), G("div", {
          key: s,
          class: "g-timeunit",
          style: F({
            background: t % 2 === 0 ? D(c).ternary : D(c).quartenary,
            color: D(c).text,
            flexDirection: D(x) === "hour" ? "column" : "row",
            alignItems: D(x) === "hour" ? "" : "center",
            width: i
          })
        }, [
          U(d.$slots, "timeunit", {
            label: s,
            value: l
          }, () => [
            rt(K(s), 1)
          ]),
          D(x) === "hour" ? (O(), G("div", {
            key: 0,
            class: "g-timeaxis-hour-pin",
            style: F({ background: D(c).text })
          }, null, 4)) : W("", !0)
        ], 4))), 128))
      ])
    ]));
  }
});
const te = { class: "g-grid-container" }, ee = /* @__PURE__ */ q({
  __name: "GGanttGrid",
  props: {
    highlightedUnits: null
  },
  setup(o) {
    const { colors: x } = A(), { timeaxisUnits: c } = Ot();
    return (w, d) => (O(), G("div", te, [
      (O(!0), G(Z, null, at(D(c).lowerUnits, ({ label: u, value: s, width: l }) => {
        var i;
        return O(), G("div", {
          key: u,
          class: "g-grid-line",
          style: F({
            width: l,
            background: (i = o.highlightedUnits) != null && i.includes(Number(s)) ? D(x).hoverHighlight : void 0
          })
        }, null, 4);
      }), 128))
    ]));
  }
});
const ne = /* @__PURE__ */ q({
  __name: "GGanttBarTooltip",
  props: {
    bar: null,
    modelValue: { type: Boolean }
  },
  setup(o) {
    const x = o, c = {
      hour: "HH:mm",
      day: "DD. MMM HH:mm",
      month: "DD. MMMM YYYY"
    }, w = "cadetblue", { bar: d } = J(x), u = A(), s = Y("0px"), l = Y("0px");
    Bt(
      () => x.bar,
      async () => {
        var p;
        await xt();
        const b = ((p = d == null ? void 0 : d.value) == null ? void 0 : p.ganttBarConfig.id) || "";
        if (!b)
          return;
        const C = document.getElementById(b), { top: g, left: v } = (C == null ? void 0 : C.getBoundingClientRect()) || {
          top: 0,
          left: 0
        }, { rowHeight: y } = u, m = Math.max(v, 10);
        s.value = `${g + y.value - 10}px`, l.value = `${m}px`;
      },
      { deep: !0, immediate: !0 }
    );
    const i = H(() => {
      var b, C;
      return ((C = (b = d == null ? void 0 : d.value) == null ? void 0 : b.ganttBarConfig.style) == null ? void 0 : C.background) || w;
    }), { toDayjs: t } = Q(), { precision: a, font: n } = u, r = H(() => {
      const b = c[a.value];
      if (d && d.value) {
        const C = t(d.value, "start").format(b), g = t(d.value, "end").format(b);
        return `${C} \u2013 ${g}`;
      }
      return "";
    });
    return (b, C) => (O(), ot(At, { to: "body" }, [
      pt(Ut, {
        name: "g-fade",
        mode: "out-in"
      }, {
        default: N(() => [
          o.modelValue ? (O(), G("div", {
            key: 0,
            class: "g-gantt-tooltip",
            style: F({
              top: s.value,
              left: l.value,
              fontFamily: D(n)
            })
          }, [
            I("div", {
              class: "g-gantt-tooltip-color-dot",
              style: F({ background: D(i) })
            }, null, 4),
            U(b.$slots, "default", {}, () => [
              rt(K(D(r)), 1)
            ])
          ], 4)) : W("", !0)
        ]),
        _: 3
      })
    ]));
  }
});
const bt = {
  default: {
    primary: "#eeeeee",
    secondary: "#E0E0E0",
    ternary: "#F5F5F5",
    quartenary: "#ededed",
    hoverHighlight: "rgba(204, 216, 219, 0.5)",
    text: "#404040",
    background: "white"
  },
  creamy: {
    primary: "#ffe8d9",
    secondary: "#fcdcc5",
    ternary: "#fff6f0",
    quartenary: "#f7ece6",
    hoverHighlight: "rgba(230, 221, 202, 0.5)",
    text: "#542d05",
    background: "white"
  },
  crimson: {
    primary: "#a82039",
    secondary: "#c41238",
    ternary: "#db4f56",
    quartenary: "#ce5f64",
    hoverHighlight: "rgba(196, 141, 141, 0.5)",
    text: "white",
    background: "white"
  },
  dark: {
    primary: "#404040",
    secondary: "#303030",
    ternary: "#353535",
    quartenary: "#383838",
    hoverHighlight: "rgba(159, 160, 161, 0.5)",
    text: "white",
    background: "#525252",
    toast: "#1f1f1f"
  },
  flare: {
    primary: "#e08a38",
    secondary: "#e67912",
    ternary: "#5e5145",
    quartenary: "#665648",
    hoverHighlight: "rgba(196, 141, 141, 0.5)",
    text: "white",
    background: "white"
  },
  fuchsia: {
    primary: "#de1d5a",
    secondary: "#b50b41",
    ternary: "#ff7da6",
    quartenary: "#f2799f",
    hoverHighlight: "rgba(196, 141, 141, 0.5)",
    text: "white",
    background: "white"
  },
  grove: {
    primary: "#3d9960",
    secondary: "#288542",
    ternary: "#72b585",
    quartenary: "#65a577",
    hoverHighlight: "rgba(160, 219, 171, 0.5)",
    text: "white",
    background: "white"
  },
  "material-blue": {
    primary: "#0D47A1",
    secondary: "#1565C0",
    ternary: "#42a5f5",
    quartenary: "#409fed",
    hoverHighlight: "rgba(110, 165, 196, 0.5)",
    text: "white",
    background: "white"
  },
  sky: {
    primary: "#b5e3ff",
    secondary: "#a1d6f7",
    ternary: "#d6f7ff",
    quartenary: "#d0edf4",
    hoverHighlight: "rgba(193, 202, 214, 0.5)",
    text: "#022c47",
    background: "white"
  },
  slumber: {
    primary: "#2a2f42",
    secondary: "#2f3447",
    ternary: "#35394d",
    quartenary: "#2c3044",
    hoverHighlight: "rgba(179, 162, 127, 0.5)",
    text: "#ffe0b3",
    background: "#38383b",
    toast: "#1f1f1f"
  },
  vue: {
    primary: "#258a5d",
    secondary: "#41B883",
    ternary: "#35495E",
    quartenary: "#2a3d51",
    hoverHighlight: "rgba(160, 219, 171, 0.5)",
    text: "white",
    background: "white"
  }
}, ae = { class: "g-gantt-rows-container" }, re = /* @__PURE__ */ q({
  __name: "GGanttChart",
  props: {
    chartStart: null,
    chartEnd: null,
    precision: { default: "day" },
    barStart: null,
    barEnd: null,
    dateFormat: { default: "YYYY-MM-DD HH:mm" },
    width: { default: "100%" },
    hideTimeaxis: { type: Boolean, default: !1 },
    colorScheme: { default: "default" },
    grid: { type: Boolean, default: !1 },
    pushOnOverlap: { type: Boolean, default: !1 },
    noOverlap: { type: Boolean, default: !1 },
    rowHeight: { default: 40 },
    highlightedUnits: { default: () => [] },
    font: { default: "inherit" }
  },
  emits: ["click-bar", "mousedown-bar", "mouseup-bar", "dblclick-bar", "mouseenter-bar", "mouseleave-bar", "dragstart-bar", "drag-bar", "dragend-bar", "contextmenu-bar"],
  setup(o, { emit: x }) {
    const c = o, { width: w, font: d, colorScheme: u } = J(c), s = Ft(), l = H(
      () => typeof u.value != "string" ? u.value : bt[u.value] || bt.default
    ), i = () => {
      var p;
      const y = (p = s.default) == null ? void 0 : p.call(s), m = [];
      return y && y.forEach((e) => {
        var f;
        if ((f = e.props) != null && f.bars) {
          const h = e.props.bars;
          m.push(h);
        } else
          Array.isArray(e.children) && e.children.forEach((h) => {
            var E;
            const B = h;
            if ((E = B == null ? void 0 : B.props) != null && E.bars) {
              const M = B.props.bars;
              m.push(M);
            }
          });
      }), m;
    }, t = Y(!1), a = Y(!1), n = Y(void 0);
    let r;
    const b = (y) => {
      r && clearTimeout(r), r = setTimeout(() => {
        t.value = !0;
      }, 800), n.value = y;
    }, C = () => {
      clearTimeout(r), t.value = !1;
    }, g = (y, m, p, e) => {
      switch (y.type) {
        case "click":
          x("click-bar", { bar: m, e: y, datetime: p });
          break;
        case "mousedown":
          x("mousedown-bar", { bar: m, e: y, datetime: p });
          break;
        case "mouseup":
          x("mouseup-bar", { bar: m, e: y, datetime: p });
          break;
        case "dblclick":
          x("dblclick-bar", { bar: m, e: y, datetime: p });
          break;
        case "mouseenter":
          b(m), x("mouseenter-bar", { bar: m, e: y });
          break;
        case "mouseleave":
          C(), x("mouseleave-bar", { bar: m, e: y });
          break;
        case "dragstart":
          a.value = !0, x("dragstart-bar", { bar: m, e: y });
          break;
        case "drag":
          x("drag-bar", { bar: m, e: y });
          break;
        case "dragend":
          a.value = !1, x("dragend-bar", { bar: m, e: y, movedBars: e });
          break;
        case "contextmenu":
          x("contextmenu-bar", { bar: m, e: y, datetime: p });
          break;
      }
    }, v = Y(null);
    return ht(kt, i), ht(Mt, {
      ...J(c),
      colors: l,
      gGanttChart: v
    }), ht(Lt, g), (y, m) => (O(), G("div", {
      ref_key: "gGanttChart",
      ref: v,
      class: "g-gantt-chart",
      style: F({ width: D(w), background: D(l).background, fontFamily: D(d) })
    }, [
      o.hideTimeaxis ? W("", !0) : (O(), ot(Qt, { key: 0 }, {
        "upper-timeunit": N(({ label: p, value: e }) => [
          U(y.$slots, "upper-timeunit", {
            label: p,
            value: e
          })
        ]),
        timeunit: N(({ label: p, value: e }) => [
          U(y.$slots, "timeunit", {
            label: p,
            value: e
          })
        ]),
        _: 3
      })),
      o.grid ? (O(), ot(ee, {
        key: 1,
        "highlighted-units": o.highlightedUnits
      }, null, 8, ["highlighted-units"])) : W("", !0),
      I("div", ae, [
        U(y.$slots, "default")
      ]),
      pt(ne, {
        "model-value": t.value || a.value,
        bar: n.value
      }, {
        default: N(() => [
          U(y.$slots, "bar-tooltip", { bar: n.value })
        ]),
        _: 3
      }, 8, ["model-value", "bar"])
    ], 4));
  }
});
function vt(o = A()) {
  const { dateFormat: x, gGanttChart: c } = o, { chartStartDayjs: w, chartEndDayjs: d, toDayjs: u } = Q(o), s = H(() => d.value.diff(w.value, "minutes"));
  return {
    mapTimeToPosition: (t) => {
      var r;
      const a = ((r = c.value) == null ? void 0 : r.getBoundingClientRect().width) || 0, n = u(t).diff(w.value, "minutes", !0);
      return Math.ceil(n / s.value * a);
    },
    mapPositionToTime: (t) => {
      var r;
      const a = ((r = c.value) == null ? void 0 : r.getBoundingClientRect().width) || 0, n = t / a * s.value;
      return w.value.add(n, "minutes").format(x.value);
    }
  };
}
function wt(o, x = () => null, c = () => null, w = A()) {
  const { barStart: d, barEnd: u, pushOnOverlap: s } = w, l = Y(!1);
  let i = 0, t;
  const { mapPositionToTime: a } = vt(w), { toDayjs: n } = Q(w), r = (p) => {
    const e = document.getElementById(o.value.ganttBarConfig.id);
    if (!e)
      return;
    switch (i = p.clientX - (e.getBoundingClientRect().left || 0), p.target.className) {
      case "g-gantt-bar-handle-left":
        document.body.style.cursor = "ew-resize", t = g;
        break;
      case "g-gantt-bar-handle-right":
        document.body.style.cursor = "ew-resize", t = v;
        break;
      default:
        t = C;
    }
    l.value = !0, window.addEventListener("mousemove", t), window.addEventListener("mouseup", m);
  }, b = () => {
    var f;
    const p = document.getElementById(o.value.ganttBarConfig.id), e = (f = p == null ? void 0 : p.closest(".g-gantt-row-bars-container")) == null ? void 0 : f.getBoundingClientRect();
    return { barElement: p, barContainer: e };
  }, C = (p) => {
    const { barElement: e, barContainer: f } = b();
    if (!e || !f)
      return;
    const h = e.getBoundingClientRect().width, B = p.clientX - f.left - i, E = B + h;
    y(B, E) || (o.value[d.value] = a(B), o.value[u.value] = a(E), x(p, o.value));
  }, g = (p) => {
    const { barElement: e, barContainer: f } = b();
    if (!e || !f)
      return;
    const h = p.clientX - f.left, B = a(h);
    n(B).isSameOrAfter(n(o.value, "end")) || (o.value[d.value] = B, x(p, o.value));
  }, v = (p) => {
    const { barElement: e, barContainer: f } = b();
    if (!e || !f)
      return;
    const h = p.clientX - f.left, B = a(h);
    n(B).isSameOrBefore(n(o.value, "start")) || (o.value[u.value] = B, x(p, o.value));
  }, y = (p, e) => {
    if (!s.value)
      return !1;
    const f = o.value.ganttBarConfig.dragLimitLeft, h = o.value.ganttBarConfig.dragLimitRight;
    return p && f != null && p < f || e && h != null && e > h;
  }, m = (p) => {
    l.value = !1, document.body.style.cursor = "", window.removeEventListener("mousemove", t), window.removeEventListener("mouseup", m), c(p, o.value);
  };
  return {
    isDragging: l,
    initDrag: r
  };
}
function St() {
  const o = mt(kt);
  if (!o)
    throw Error("Failed to inject getChartRows!");
  return o;
}
function Tt() {
  const o = mt(Lt);
  if (!o)
    throw Error("Failed to inject emitBarEvent!");
  return o;
}
function oe() {
  const o = A(), x = St(), c = Tt(), { pushOnOverlap: w, barStart: d, barEnd: u, noOverlap: s, dateFormat: l } = o, i = /* @__PURE__ */ new Map(), { toDayjs: t } = Q(), a = (e, f) => {
    const { initDrag: h } = wt(Y(e), r, y, o), B = {
      ...f,
      type: "dragstart"
    };
    c(B, e), h(f), m(e);
  }, n = (e, f) => {
    const h = e.ganttBarConfig.bundle;
    h != null && (x().forEach((B) => {
      B.forEach((E) => {
        if (E.ganttBarConfig.bundle === h) {
          const M = E === e ? y : () => null, { initDrag: _ } = wt(Y(E), r, M, o);
          _(f), m(E);
        }
      });
    }), c({ ...f, type: "dragstart" }, e));
  }, r = (e, f) => {
    c({ ...e, type: "drag" }, f), b(f);
  }, b = (e) => {
    if (!(w != null && w.value))
      return;
    let f = e, { overlapBar: h, overlapType: B } = C(f);
    for (; h; ) {
      m(h);
      const E = t(f[d.value]), M = t(f[u.value]), _ = t(h[d.value]), L = t(h[u.value]);
      let k;
      switch (B) {
        case "left":
          k = L.diff(E, "minutes", !0), h[u.value] = E.format(l.value), h[d.value] = _.subtract(k, "minutes").format(l.value);
          break;
        case "right":
          k = M.diff(_, "minutes", !0), h[d.value] = M.format(l.value), h[u.value] = L.add(k, "minutes").format(l.value);
          break;
        default:
          console.warn(
            "Vue-Ganttastic: One bar is inside of the other one! This should never occur while push-on-overlap is active!"
          );
          return;
      }
      h && (B === "left" || B === "right") && g(h, k, B), f = h, { overlapBar: h, overlapType: B } = C(h);
    }
  }, C = (e) => {
    let f, h, B;
    const E = x().find((S) => S.includes(e)) || [], M = t(e[d.value]), _ = t(e[u.value]), L = E.find((S) => {
      if (S === e)
        return !1;
      const T = t(S[d.value]), $ = t(S[u.value]);
      return f = M.isBetween(T, $), h = _.isBetween(T, $), B = T.isBetween(M, _) || $.isBetween(M, _), f || h || B;
    });
    let k = null;
    return k = f ? "left" : h ? "right" : B ? "between" : null, { overlapBar: L, overlapType: k };
  }, g = (e, f, h) => {
    m(e), !e.ganttBarConfig.bundle && x().forEach((B) => {
      B.forEach((E) => {
        E.ganttBarConfig.bundle === e.ganttBarConfig.bundle && E !== e && (m(E), v(E, f, h));
      });
    });
  }, v = (e, f, h) => {
    switch (h) {
      case "left":
        e[d.value] = t(e, "start").subtract(f, "minutes").format(l.value), e[u.value] = t(e, "end").subtract(f, "minutes").format(l.value);
        break;
      case "right":
        e[d.value] = t(e, "start").add(f, "minutes").format(l.value), e[u.value] = t(e, "end").add(f, "minutes").format(l.value);
    }
    b(e);
  }, y = (e, f) => {
    p();
    const h = {
      ...e,
      type: "dragend"
    };
    c(h, f, void 0, new Map(i)), i.clear();
  }, m = (e) => {
    if (!i.has(e)) {
      const f = e[d.value], h = e[u.value];
      i.set(e, { oldStart: f, oldEnd: h });
    }
  }, p = () => {
    if (w.value || !s.value)
      return;
    let e = !1;
    i.forEach((f, h) => {
      const { overlapBar: B } = C(h);
      B != null && (e = !0);
    }), e && i.forEach(({ oldStart: f, oldEnd: h }, B) => {
      B[d.value] = f, B[u.value] = h;
    });
  };
  return {
    initDragOfBar: a,
    initDragOfBundle: n
  };
}
function ie() {
  const { pushOnOverlap: o } = A(), x = St(), c = (s) => {
    const l = [];
    return s != null && x().forEach((i) => {
      i.forEach((t) => {
        t.ganttBarConfig.bundle === s && l.push(t);
      });
    }), l;
  }, w = (s) => {
    if (!o.value || s.ganttBarConfig.pushOnOverlap === !1)
      return;
    for (const i of ["left", "right"]) {
      const t = i, { gapDistanceSoFar: a, bundleBarsAndGapDist: n } = d(
        s,
        0,
        t
      );
      let r = a;
      const b = n;
      if (!b)
        continue;
      for (let g = 0; g < b.length; g++) {
        const v = b[g].bar, y = b[g].gapDistance;
        c(v.ganttBarConfig.bundle).filter(
          (p) => p !== v
        ).forEach((p) => {
          const e = d(p, y, t), f = e.gapDistanceSoFar, h = e.bundleBarsAndGapDist;
          f != null && (!r || f < r) && (r = f), h.forEach((B) => {
            b.find((E) => E.bar === B.bar) || b.push(B);
          });
        });
      }
      const C = document.getElementById(s.ganttBarConfig.id);
      r != null && t === "left" ? s.ganttBarConfig.dragLimitLeft = C.offsetLeft - r : r != null && t === "right" && (s.ganttBarConfig.dragLimitRight = C.offsetLeft + C.offsetWidth + r);
    }
    c(s.ganttBarConfig.bundle).forEach((i) => {
      i.ganttBarConfig.dragLimitLeft = s.ganttBarConfig.dragLimitLeft, i.ganttBarConfig.dragLimitRight = s.ganttBarConfig.dragLimitRight;
    });
  }, d = (s, l = 0, i) => {
    const t = s.ganttBarConfig.bundle ? [{ bar: s, gapDistance: l }] : [];
    let a = s, n = u(a, i);
    if (i === "left")
      for (; n; ) {
        const r = document.getElementById(a.ganttBarConfig.id), b = document.getElementById(n.ganttBarConfig.id), C = b.offsetLeft + b.offsetWidth;
        if (l += r.offsetLeft - C, n.ganttBarConfig.immobile)
          return { gapDistanceSoFar: l, bundleBarsAndGapDist: t };
        n.ganttBarConfig.bundle && t.push({
          bar: n,
          gapDistance: l
        }), a = n, n = u(n, "left");
      }
    if (i === "right")
      for (; n; ) {
        const r = document.getElementById(a.ganttBarConfig.id), b = document.getElementById(n.ganttBarConfig.id), C = r.offsetLeft + r.offsetWidth;
        if (l += b.offsetLeft - C, n.ganttBarConfig.immobile)
          return { gapDistanceSoFar: l, bundleBarsAndGapDist: t };
        n.ganttBarConfig.bundle && t.push({
          bar: n,
          gapDistance: l
        }), a = n, n = u(n, "right");
      }
    return { gapDistanceSoFar: null, bundleBarsAndGapDist: t };
  }, u = (s, l) => {
    const i = document.getElementById(s.ganttBarConfig.id), t = x().find((n) => n.includes(s)) || [];
    let a = [];
    return l === "left" ? a = t.filter((n) => {
      const r = document.getElementById(n.ganttBarConfig.id);
      return r && r.offsetLeft < i.offsetLeft && n.ganttBarConfig.pushOnOverlap !== !1;
    }) : a = t.filter((n) => {
      const r = document.getElementById(n.ganttBarConfig.id);
      return r && r.offsetLeft > i.offsetLeft && n.ganttBarConfig.pushOnOverlap !== !1;
    }), a.length > 0 ? a.reduce((n, r) => {
      const b = document.getElementById(n.ganttBarConfig.id), C = document.getElementById(r.ganttBarConfig.id), g = Math.abs(b.offsetLeft - i.offsetLeft), v = Math.abs(C.offsetLeft - i.offsetLeft);
      return g < v ? n : r;
    }, a[0]) : null;
  };
  return {
    setDragLimitsOfGanttBar: w
  };
}
const se = ["id"], le = { class: "g-gantt-bar-label" }, ue = /* @__PURE__ */ I("div", { class: "g-gantt-bar-handle-left" }, null, -1), ce = /* @__PURE__ */ I("div", { class: "g-gantt-bar-handle-right" }, null, -1), de = /* @__PURE__ */ q({
  __name: "GGanttBar",
  props: {
    bar: null
  },
  setup(o) {
    const x = o, c = Tt(), w = A(), { rowHeight: d } = w, { bar: u } = J(x), { mapTimeToPosition: s, mapPositionToTime: l } = vt(), { initDragOfBar: i, initDragOfBundle: t } = oe(), { setDragLimitsOfGanttBar: a } = ie(), n = Y(!1), r = H(() => u.value.ganttBarConfig);
    function b(_) {
      r.value.bundle != null ? t(u.value, _) : i(u.value, _), n.value = !0;
    }
    const C = () => {
      a(u.value), !r.value.immobile && (window.addEventListener("mousemove", b, {
        once: !0
      }), window.addEventListener(
        "mouseup",
        () => {
          window.removeEventListener("mousemove", b), n.value = !1;
        },
        { once: !0 }
      ));
    }, g = Y(null), v = (_) => {
      var S, T;
      _.preventDefault(), _.type === "mousedown" && C();
      const L = (T = (S = g.value) == null ? void 0 : S.closest(".g-gantt-row-bars-container")) == null ? void 0 : T.getBoundingClientRect();
      let k;
      L && (k = l(_.clientX - L.left)), c(_, u.value, k);
    }, { barStart: y, barEnd: m, width: p, chartStart: e, chartEnd: f } = w, h = Y(0), B = Y(0);
    function E() {
      h.value = s(u.value[y.value]), B.value = s(u.value[m.value]);
    }
    Bt(
      [u, p, e, f],
      async () => {
        await xt(), E();
      },
      { deep: !0, immediate: !0 }
    ), It(() => window.addEventListener("resize", E)), jt(() => window.removeEventListener("resize", E));
    const M = H(() => ({
      ...r.value.style,
      position: "absolute",
      top: `${d.value * 0.1}px`,
      left: `${h.value}px`,
      width: `${B.value - h.value}px`,
      height: `${d.value * 0.8}px`,
      zIndex: n.value ? 3 : 2
    }));
    return (_, L) => (O(), G("div", {
      id: D(r).id,
      class: "g-gantt-bar",
      style: F(D(M)),
      onMousedown: v,
      onClick: v,
      onDblclick: v,
      onMouseenter: v,
      onMouseleave: v,
      onContextmenu: v
    }, [
      I("div", le, [
        U(_.$slots, "default", { bar: D(u) }, () => [
          I("div", null, K(D(r).label || ""), 1)
        ])
      ]),
      D(r).hasHandles ? (O(), G(Z, { key: 0 }, [
        ue,
        ce
      ], 64)) : W("", !0)
    ], 44, se));
  }
});
const fe = /* @__PURE__ */ q({
  __name: "GGanttRow",
  props: {
    label: null,
    bars: null,
    highlightOnHover: { type: Boolean }
  },
  emits: ["drop"],
  setup(o, { emit: x }) {
    const c = o, { rowHeight: w, colors: d } = A(), { highlightOnHover: u } = J(c), s = Y(!1), l = H(() => ({
      height: `${w.value}px`,
      background: (u == null ? void 0 : u.value) && s.value ? d.value.hoverHighlight : null
    })), { mapPositionToTime: i } = vt(), t = Y(null), a = (n) => {
      var g;
      const r = (g = t.value) == null ? void 0 : g.getBoundingClientRect();
      if (!r) {
        console.error("Vue-Ganttastic: failed to find bar container element for row.");
        return;
      }
      const b = n.clientX - r.left, C = i(b);
      x("drop", { e: n, datetime: C });
    };
    return (n, r) => (O(), G("div", {
      class: "g-gantt-row",
      style: F(D(l)),
      onDragover: r[0] || (r[0] = zt((b) => s.value = !0, ["prevent"])),
      onDragleave: r[1] || (r[1] = (b) => s.value = !1),
      onDrop: r[2] || (r[2] = (b) => a(b)),
      onMouseover: r[3] || (r[3] = (b) => s.value = !0),
      onMouseleave: r[4] || (r[4] = (b) => s.value = !1)
    }, [
      I("div", {
        class: "g-gantt-row-label",
        style: F({ background: D(d).primary, color: D(d).text })
      }, [
        U(n.$slots, "label", {}, () => [
          rt(K(o.label), 1)
        ])
      ], 4),
      I("div", Pt({
        ref_key: "barContainer",
        ref: t,
        class: "g-gantt-row-bars-container"
      }, n.$attrs), [
        pt(Vt, {
          name: "bar-transition",
          tag: "div"
        }, {
          default: N(() => [
            (O(!0), G(Z, null, at(o.bars, (b) => (O(), ot(de, {
              key: b.ganttBarConfig.id,
              bar: b
            }, {
              default: N(() => [
                U(n.$slots, "bar-label", { bar: b })
              ]),
              _: 2
            }, 1032, ["bar"]))), 128))
          ]),
          _: 3
        })
      ], 16)
    ], 36));
  }
});
function ge() {
  V.extend(Nt), V.extend(qt), V.extend(Xt), V.extend(Zt);
}
const ve = {
  install(o, x) {
    ge(), o.component("GGanttChart", re), o.component("GGanttRow", fe);
  }
};
function X(o, x = "top") {
  if (!o || typeof document > "u")
    return;
  const c = document.head, w = document.createElement("style");
  x === "top" && c.firstChild ? c.insertBefore(w, c.firstChild) : c.appendChild(w), w.appendChild(document.createTextNode(o));
}
X(`
.g-gantt-row {
  width: 100%;
  transition: background 0.4s;
  position: relative;
}
.g-gantt-row > .g-gantt-row-bars-container {
  position: relative;
  border-top: 1px solid #eaeaea;
  width: 100%;
  border-bottom: 1px solid #eaeaea;
}
.g-gantt-row-label {
  position: absolute;
  top: 0;
  left: 0px;
  padding: 0px 8px;
  display: flex;
  align-items: center;
  height: 60%;
  min-height: 20px;
  font-size: 0.8em;
  font-weight: bold;
  border-bottom-right-radius: 6px;
  background: #f2f2f2;
  z-index: 3;
  box-shadow: 0px 1px 4px 0px rgba(0, 0, 0, 0.6);
}
.bar-transition-leave-active,
.bar-transition-enter-active {
  transition: all 0.2s;
}
.bar-transition-enter-from,
.bar-transition-leave-to {
  transform: scale(0.8);
  opacity: 0;
}
`, "top");
X(`
.g-gantt-chart {
  position: relative;
  display: flex;
  flex-direction: column;
  overflow-x: hidden;
  -webkit-touch-callout: none;
  -webkit-user-select: none;
     -moz-user-select: none;
          user-select: none;
  border-radius: 5px;
  font-feature-settings: "tnum";
  font-variant-numeric: tabular-nums;
}
.g-gantt-rows-container {
  position: relative;
}
`, "top");
X(`
.g-gantt-bar {
  display: flex;
  justify-content: center;
  align-items: center;
  background: cadetblue;
  overflow: hidden;
}
.g-gantt-bar-label {
  width: 100%;
  height: 100%;
  box-sizing: border-box;
  padding: 0 14px 0 14px; /* 14px is the width of the handle */
  display: flex;
  justify-content: center;
  align-items: center;
}
.g-gantt-bar-label > * {
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
}
.g-gantt-bar-handle-left,
.g-gantt-bar-handle-right {
  position: absolute;
  width: 10px;
  height: 100%;
  background: white;
  opacity: 0.7;
  border-radius: 0px;
  cursor: ew-resize;
  top: 0;
}
.g-gantt-bar-handle-left {
  left: 0;
}
.g-gantt-bar-handle-right {
  right: 0;
}
.g-gantt-bar-label img {
  pointer-events: none;
}
`, "top");
X(`
.g-timeaxis {
  position: sticky;
  top: 0;
  width: 100%;
  height: 8vh;
  min-height: 75px;
  background: white;
  z-index: 4;
  box-shadow: 0px 1px 3px 2px rgba(50, 50, 50, 0.5);
  display: flex;
  flex-direction: column;
}
.g-timeunits-container {
  display: flex;
  width: 100%;
  height: 50%;
}
.g-timeunit {
  height: 100%;
  font-size: 65%;
  display: flex;
  flex-direction: column;
  justify-content: center;
}
.g-upper-timeunit {
  display: flex;
  height: 100%;
  justify-content: center;
  align-items: center;
}
.g-timeaxis-hour-pin {
  width: 1px;
  height: 10px;
}
`, "top");
X(`
.g-grid-container {
  position: absolute;
  top: 0;
  left: 0%;
  width: 100%;
  height: 100%;
  display: flex;
  justify-content: space-between;
}
.g-grid-line {
  width: 1px;
  height: 100%;
  border-left: 1px solid #eaeaea;
}
`, "top");
X(`
.g-gantt-tooltip {
  position: fixed;
  background: black;
  color: white;
  z-index: 4;
  font-size: 0.85em;
  padding: 5px;
  border-radius: 3px;
  transition: opacity 0.2s;
  display: flex;
  align-items: center;
  font-feature-settings: "tnum";
  font-variant-numeric: tabular-nums;
}
.g-gantt-tooltip:before {
  content: "";
  position: absolute;
  top: 0;
  left: 10%;
  width: 0;
  height: 0;
  border: 10px solid transparent;
  border-bottom-color: black;
  border-top: 0;
  margin-left: -5px;
  margin-top: -5px;
}
.g-gantt-tooltip-color-dot {
  width: 8px;
  height: 8px;
  border-radius: 100%;
  margin-right: 4px;
}
.g-fade-enter-active,
.g-fade-leave-active {
  transition: opacity 0.3s ease;
}
.g-fade-enter-from,
.g-fade-leave-to {
  opacity: 0;
}
`, "top");
export {
  re as GGanttChart,
  fe as GGanttRow,
  ve as default,
  ge as extendDayjs,
  ve as ganttastic
};
